#include "myfndt.h"
#include "idxstor.h"
#include "crunopt.h"
#include "buildp.h"
#include "oindex.h"

//#define DEBUG_sequence

CIndexStorage::CIndexStorage(
	CCompressedStrHandler *WordTreeHandler,
	CCruncherOptions &Options):
	CStorage(WordTreeHandler,
		Options.Get(O_WORDTREEEXT),
		new CDatumFactoryTemplate<COccBuilder>(),
		Options.Get(O_OCCSTOREFREELISTEXT),
		Options.Get(O_OCCSTOREDATAEXT),
		IT_CREATE | IT_UPDATE,
		CRemTable::DefaultLimit,
		CRemTable::DefaultDelta,
		1) // minimal cache - words are pre-sorted
{
}

CIndexStorage::~CIndexStorage()
{
}

void CIndexStorage::IndexWord(const DString &CurWord,
	ulong *OccArray, ushort OccCount)
{
#if defined(DEBUG_sequence)
	const char *x = CurWord.c_str();
#endif
	CNewKey Key(CCompressedStrHandler::NewKey(CurWord.c_str()));
	CDatumEnvelopeTemplate<COccBuilder> Envelope =
			static_cast<COccBuilder *>(LockAlways(Key));
	Assert(Envelope != NULL);
	Envelope->Add(OccArray, OccCount);
}

short CIndexStorage::DelWord(const DString &CurWord)
{
	CNewKey Key(CCompressedStrHandler::NewKey(CurWord.c_str()));
	return CStorage::Del(Key);
}

