#if !defined(__manip_h)
#define __manip_h

#include "reporter.h"

/* For CConveyor, Borland tries to generate
	DIArray<CManipulator>::DIArray<CManipulator>(const DIArray<CManipulator> &).
	That is impossible if CManipulator is abstract class */
#if defined(__BORLANDC__) && !defined(USE_STL)
#define ABSTRACT_HACK      ;
#else
#define ABSTRACT_HACK		= 0;
#endif

class CManipulator
{
private:
	CReporter *Reporter;

public:
	// takes ownership of reporter
	CManipulator(CReporter *aReporter);
	virtual ~CManipulator();

protected:
	virtual short IsFilled() ABSTRACT_HACK
	virtual short GetPerc() { return 0; }
public:
	virtual short Shuffle() ABSTRACT_HACK
protected:
	virtual void CleanUp(); // empty

protected:
	void ReportProgress(short IsActive, unsigned short Perc)
		{ if (Reporter) Reporter->ReportProgress(IsActive, Perc); }
	void ReportIn()
		{ if (Reporter) Reporter->ReportIn(); }
	virtual void InformNext() ABSTRACT_HACK

public:
#if defined(NOCPCONSTRUCT)
	int operator == (const CManipulator *Other)
		{ return (ulong)this == (ulong)Other; }
	int operator < (const CManipulator *Other)
		{ return (ulong)this < (ulong)Other; }
	int operator > (const CManipulator *Other)
		{ return (ulong)this > (ulong)Other; }
#else
	int operator == (const CManipulator &Other) const
		{ return (ulong)this == (ulong)(&Other); }
	int operator < (const CManipulator &Other) const
		{ return (ulong)this < (ulong)(&Other); }
#endif

#if defined(__BORLANDC__) && !defined(USE_STL)
public:
#else
private:
#endif
	CManipulator(const CManipulator &); // not defined/not usable
};

#endif

