#include "myfndt.h"
#include "occblock.h"

//#define DEBUG_WordCache

#if defined(DEBUG_OccBlock)
#include <stdio.h>
#endif

COccBlock::COccBlock(int aSize):
	DISArray<CComposedOcc>(aSize, 0)
{
}

COccBlock::~COccBlock()
{
}

void COccBlock::SetIn(CSimpleOcc *InSimpleOcc)
{    CComposedOcc *ChangedOcc;

     CObjPtr<CSimpleOcc> SimpleOcc = InSimpleOcc;

	CObjPtr<CComposedOcc> NewOcc = new CComposedOcc(SimpleOcc->GetWord());
	int FindIdx = Find(NewOcc);
	if (FindIdx == INT_MAX) // not found
	{    NewOcc->Add(SimpleOcc->GetData());
		Add(NewOcc.Drop());
	}
	else
	{	ChangedOcc = DISArray<CComposedOcc>::operator[](FindIdx);
		ChangedOcc->Add(SimpleOcc->GetData());
	}
}

/*void COccBlock::SetIn(CComposedOcc *ComposedOcc)
{
     Add(ComposedOcc);
}*/

/*CComposedOcc *COccBlock::YankHead()
{
	Assert(GetCount());
	CComposedOcc *Occ =	DISArray<CComposedOcc>::operator[](0);
	DetachByIndex(0);
	return Occ;
}*/

#if defined(DEBUG_OccBlock)
void COccBlock::Print()
{
     static int n = 0;
     printf("----block---- %d\n", n);
	n++;
	DISArray<CComposedOcc>::DIterator Itr = InitIterator();
	while (IsDereferenceable(Itr))
	{    CComposedOcc *Occ = GetCurrent(Itr);    
		printf("%s\n", Occ->GetWord().c_str());
		++Itr;
	}
	printf("\n");
}
#endif
