#if !defined(__wcache_h)
#define __wcache_h

#include "socc.h"
#include "cocc.h"
#include "arrays.h"
#include "wcabstm.h"
#include "wcmember.h"

//#define DEBUG_CWordCache

class CWordCache
{
public:
	static const int DefaultLimit;
	static const int DefaultMaxMemberOccCount;

private:
	DISArray<CWordCacheAbstractMember> CacheArr;
	CString *FirstKeyAlias;
	CString *LastKeyAlias;
	const int MaxMemberOccCount;

public:
	CWordCache(int aLimit = DefaultLimit,
	    int aMaxMemberOccCount = DefaultMaxMemberOccCount);
	CComposedOcc *NewMerge(CSimpleOcc *InOcc);
	CComposedOcc *YankFirst();
	CComposedOcc *YankNeighbor();
	int IsEmpty();

private:
	int FindIndex(const CString &Key);
     CWordCacheMember *Detach(const CString &Key, int Idx);
     CComposedOcc *Yank(const CString &Key);
	int LastYankedIndex;

	CWordCacheMember *GetPrev(int Idx);
	CWordCacheMember *GetNext(int Idx);
	void SkipPrev(CWordCacheMember *Member);
	void SkipNext(CWordCacheMember *Member);
#if defined(DEBUG_CWordCache)
	void CheckArr();
#endif
};

#endif
