#include "myfndt.h"
#include "wcmember.h"

CWordCacheMember::CWordCacheMember(CSimpleOcc *SimpleOcc,
    CString *aPrevKeyAlias,
    CString *aNextKeyAlias):
    Occ(new CComposedOcc(SimpleOcc->GetWord())),
    PrevKeyAlias(aPrevKeyAlias),
    NextKeyAlias(aNextKeyAlias)
{
    Occ->Add(SimpleOcc->GetData());
}

CWordCacheMember::~CWordCacheMember()
{
    delete Occ;
}

const CString &CWordCacheMember::GetKey() const
{
    Assert(Occ != NULL); 
    return Occ->GetWord(); 
}

CComposedOcc *CWordCacheMember::DropOcc()
{
    Assert(Occ != NULL); 
    CComposedOcc *OutOcc = Occ;
    Occ = NULL;
    return OutOcc;
}

void CWordCacheMember::Merge(CSimpleOcc *SimpleOcc)
{
    Assert(Occ != NULL); 
    Occ->Add(SimpleOcc->GetData());
}

int CWordCacheMember::OccCount()
{
    Assert(Occ != NULL); 
    return Occ->GetOccCount();
}

