#include "myfndt.h"
#include "figure.h"
#include "hstone.h"

CFigure::CFigure(const DString &Dir):
    CBook(new CStoneHandler, Dir, IT_TEMP | IT_UPDATE),
    Foreground(new CULongHandler, Dir, IT_TEMP | IT_UPDATE),
    StoneCount(0)
{
}

int CFigure::AddForegroundDoc(ulong Doc)
{
    CNewKey Key(CULongHandler::NewKey(Doc));
    return Foreground.Add(Key, 0);
}

int CFigure::IsInForeground(ulong Doc)
{   long dummy;

    CNewKey Key(CULongHandler::NewKey(Doc));
    return !Foreground.GetData(Key, dummy);
}

int CFigure::AddStone(const CStone &Stone)
{
    CNewKey Key(CStoneHandler::NewKey(&Stone));
    int ret = CBook::Add(Key, 0);
    if (!ret)
	   ++StoneCount;
    return ret;
}

CStone CFigure::GetStone(KEY Key)
{
    return CStoneHandler::GetStone(Key);
}
