#if !defined(__formdisp_h)
#define __formdisp_h

#include "abstdisp.h"

class CMirror;
class CResult;
class CGrazerOptions;
class DDocument;
class CRelevance;
class CClot;
class CPunctParse;

class CFormDisplay : public CAbstractDisplay
{
public:
    CFormDisplay(CMirror &aMirror,
	   CResult &aResult,
	   CGrazerOptions &aOptions);
    virtual ~CFormDisplay();

    virtual void Display();

private:
    CMirror &Mirror;
    CResult &Result;
    CGrazerOptions &Options;
    CFileObj OutFile;
    int SkipClots;
    CPunctParse *PunctParse;

    void DisplayUnindexed();
    void DisplayProlog();
    void DisplayEpilog();
    void DisplayDoc(DDocument *InDoc);
    void DisplayDocContents(DDocument *Doc);
    void DisplayRelevance(CRelevance *Relevance, double RelRes);
    int DisplayClot(CClot *Clot, int &HighlightCount);
    void DisplayPassage(const DString &Passage, 
        const char *Template,
	   int ColorCode);

    void ErrPrint(const DString &Buffer);
    void OutPrint(const DString &Buffer);

    int IsEmpty(const char *Name);
#if defined(__GNUG__)
    void OutPrintStep(const char *Buffer);
#endif
};

#endif
