#include "myfndt.h"
#include "hstone.h"

const int CStoneHandler::Fixed = 4 * sizeof(long);

KEY CStoneHandler::NewKey(const CStone *Stone)
{
    int Var = Stone->SWord.GetLength() + 1;
    KEY ret = CKeyHandler::NewKey(Fixed + Var);
    memcpy(ret, Stone, Fixed);
    memcpy(((char *)ret) + Fixed, Stone->SWord.c_str(), Var);
    return ret;
}

CStone CStoneHandler::GetStone(KEY Key)
{
    return CStone(DString(((char *)Key) + Fixed),
        *((long *)Key),
	   *(((long *)Key) + 1),
	   *(((long *)Key) + 2),
	   *(((long *)Key) + 3));
}

KEY CStoneHandler::NewCopy(KEY Key)
{
    ushort Size = GetMemorySize(Key);
    KEY ret = CKeyHandler::NewKey(Size);
    memcpy(ret, Key, Size);
    return ret;
}

KEY CStoneHandler::Load(KEY PrevKey, CFileObj *Stream)
{   ushort MemSize;

    Stream->Read(&MemSize, sizeof(ushort));
    Assert(MemSize > 0);
    KEY Key = CKeyHandler::NewKey(MemSize);
    Stream->Read(Key, MemSize);
    return Key;
}

void CStoneHandler::Save(KEY PrevKey, KEY Key, CFileObj *Stream)
{
    ushort MemSize = GetMemorySize(Key);
    Stream->Write(&MemSize, sizeof(ushort));
    Stream->Write(Key, MemSize);
}

ushort CStoneHandler::GetDiskLen(KEY PrevKey, KEY Key)
{
    return sizeof(ushort) + GetMemorySize(Key);
}

ushort CStoneHandler::GetAveDiskLen()
{
    return sizeof(ushort) + GetAveKeyLen();
}

ushort CStoneHandler::GetAveKeyLen()
{
    return 5; // should be a parameter
}

short CStoneHandler::Compare(KEY Key1, KEY Key2)
{
    CStone Stone1 = GetStone(Key1);
    CStone Stone2 = GetStone(Key2);
    return -1 * Stone1.Compare(Stone2); // high to low
}

ushort CStoneHandler::GetMemorySize(KEY Key)
{
    return Fixed + strlen(((char *)Key) + Fixed) + 1;
}
