#if !defined(__numclot_h)
#define __numclot_h

#include "cluster.h"
#include "arrays.h"

class CNumClot
{
// parameters
public:
	static const int DefaultLimit;
	static const int DefaultDelta;

// members
private:
#if !defined(USE_STL)
	TArrayAsVector<ushort> Passage;
#else
	DArray<ushort> Passage;
#endif
	CCluster HeadCluster;
	ushort Sum;
	short FirstHigh;

public:
	CNumClot(CCluster &aHeadCluster,
		int aLimit = DefaultLimit,
		int aDelta = DefaultDelta);
	~CNumClot();

	void Add(ulong WordNum);
		// adds two passages or coalesces adjacent spots into
		// one passage
	short IsFirstLow();
		// asserts Passage is not empty

	int GetHeadDist();
		// asserts Passage is not empty

	long GetOffs() { return HeadCluster.GetOffs(); }
	short GetPassageCount(ushort Index, ushort &Count);
		// returns 0 OK (Count is output params), 1 Index too big

private:
	void AddSeparate(ushort Delta);
};

#endif
