#include "myfndt.h"
#include "timerep.h"
#include <stdio.h>

CTimeReporter::CTimeReporter(time_t aDelta, const DString &aFormat):
    Current(time(NULL)),
    Delta(aDelta),
    Format(aFormat),
    Total(0)
{
}

CTimeReporter::~CTimeReporter()
{
}

void CTimeReporter::ReportProgress(short, short Perc)
{
    time_t NowTime = time(NULL);
    Assert(NowTime >= Current);
    time_t NowDelta = NowTime - Current;
    if (NowDelta < Delta)
	   return;

    Current = NowTime;
    if (Perc < 0)
	   Perc = 0;
    else
	   if (Perc > 100)
		  Perc = 100;

	printf(Format.c_str(), Total, Perc);
}

void CTimeReporter::ReportIn()
{
    Total++;
}

void CTimeReporter::Reset()
{
    Current = time(NULL);
}
