#include "myfndt.h"

void Run(int Count, char *Argv[]);

int main(int argc, char *argv[])
{
	try
	{	
		Run(argc, argv);
		return 0;
	}
	catch (DAssertException &x)
	{	printf("exception:\n%s\naborting...\n", x.GetInfo());
		return -1;
	}
	catch (DMemoryException &x)
	{	printf("exception:\nallocation of %d bytes failed\naborting...\n",
			x.requested());
		return -1;
	}
	catch (COpenException &x)
	{	printf("exception:\ncould not open file (directory) %s with mode %s\n"
			   "aborting...\n", x.GetFile(), x.GetMode());
		return -1;
	}
	catch (CReadException &x)
	{	printf("exception:\ncould not read from file\naborting...\n");
		return -1;
	}
	catch (CWriteException &x)
	{	printf("exception:\ncould not write to file\naborting...\n");
		return -1;
	}
	catch (DException &x)
		// under gcc, this will _not_ catch COpenException nor any
		// other descendants
	{	DString Why = 
#if !defined(_MSC_VER)
			x.why();
#else
			x.what();
#endif
	     printf("exception:\n%s\naborting...\n", Why.c_str());
		return -1;
	}
	catch (...)
	{	printf ("unknown exception!\naborting...\n");
		return -1;
	}
}

