#if !defined(__recbase_h)
#define __recbase_h

class CRecBase // could be template
{
private:
// parameters & types
	static const ushort PackThreshold;
   static const uchar EmptyFlag;
	struct SBaseHeader;

// members
	CFileObj Stream;
	const ushort RecSize;

public:
	CRecBase(const DString &BaseName, ushort Opt, ushort aRecSize);
	virtual ~CRecBase();

	ulong Add();
	void Del(ulong Offs);
	void *Alloc(ulong Offs);
	void Put(ulong Offs, const void *Stuff);

	short GetFirst(ulong &Offs);
		// 0 OK, Offs is out param; 1 base empty
	short GetLast(ulong &Offs);
		// 0 OK, Offs is out param; 1 base empty

	void StoreAll() { Stream.Flush(); }

private:
	ushort GetInternalRecSize() { return (ushort)(1 + RecSize); }
	void ReadHeader(SBaseHeader &Header);
	void WriteHeader(SBaseHeader &Header);
	void PackStep();
	void PackFromOffs(ulong Offs);
	void MoveTail(ulong Dest, ulong Src);
   	// shortens the file
};

#endif

