#if !defined(__watch_h)
#define __watch_h

#include "rxw.h"
#include "arrays.h"

class CLocusOptions;
class CUnivOptions;
class CChange;
class CStringListValue;

class CWatch
{
public:
    CWatch(const CRegex &aDocBegin = CRegex(DString("")), short aMargin = 0);
	// w/o subdocs - grazer
    CWatch(CLocusOptions &Options);
        // full - for cruncher
    virtual ~CWatch();

    static void SetSubdocClass(CUnivOptions &Options,
	const CStringListValue &DocParts);

    short GetMargin() const;
    short GetValidSize(const char *Chunk, short ReadSize, int FromBegin);
    void Iterate(const char *Chunk, CChange &Change);

private:
    short Margin;
    CRegex DocBegin;
    DArray<CRegex> PushMatch;
    DArray<CRegex> PopMatch;

    // returns 0 no match, 1 found match (out params valid)
    int GetPushMatch(const char *Chunk,
        int &From, // out
	int &To, // out
	short &SubdocId); // out
    // returns 0 no match, 1 found match (out params valid)
    int GetPopMatch(const char *Chunk,
	short Subdoc, // must not be 0 (plaintext)
        int &From, // out
	int &To); // out
};

#endif
