#include "myfndt.h"
#include "rxletter.h"

CRegexLetter::CRegexLetter(const DString &Source):
    Count(1)
{
    Assert(!Source.IsEmpty());
    int r = regcomp(&Regex, Source.c_str(), REG_EXTENDED | REG_NEWLINE);
    if (r)
    {   char ErrBuf[100];
        regerror(r, &Regex, ErrBuf, 100);
        printf("%s\n", ErrBuf);
        throw CGeneralException(ErrBuf);
    }
}

CRegexLetter::~CRegexLetter()
{
    regfree(&Regex);
}

void CRegexLetter::AddRef()
{
    ++Count;
}

void CRegexLetter::DelRef()
{
    if (--Count <= 0)
        delete this;
}

int CRegexLetter::Matches(const char *String, int &From, int &To) const
{   regmatch_t Match;

    if (regexec(&Regex, String, 1, &Match, 0))
    {   From = To = -1;
        return 0;
    }
    else
    {   From = Match.rm_so;
        To = Match.rm_eo;
        return 1;
    }
}

