#include "myfndt.h"
#include "rxw.h"
#include "rxletter.h"

CRegex::CRegex():
    Letter(NULL)
{
}

CRegex::CRegex(const DString &Regex):
    Letter(NULL)
{
    if (!Regex.IsEmpty())
        Letter = new CRegexLetter(Regex);
}

CRegex::CRegex(const CRegex &Other):
    Letter(Other.Letter)
{
    if (Letter)
        Letter->AddRef();
}

CRegex::~CRegex()
{
    if (Letter)
        Letter->DelRef();
}

CRegex &CRegex::operator = (const CRegex &Other)
{
    if (Other.Letter)
        Other.Letter->AddRef();
    if (Letter)
        Letter->DelRef();
    Letter = Other.Letter;
    return *this;
}

int CRegex::Matches(const char *String, int &From, int &To) const
{
    if (!Letter)
    {   From = To = -1;
        return 0;
    }
    return Letter->Matches(String, From, To);
}
